var ID = 1; // 全局变量
/**
 * 商户端接入js库
 */
var ThirdApp = {
	os: null,


	/**
	 * 获取核心用户号，然后跳转到url,并在url末尾附加coreCustNo=XXX
	 * 
	 * @param url
	 */
	getCoreCustNo: function (url) {
		if (ThirdApp.os == 'android') {
			window.SysClientJs.getCoreCustNo(url);
		} else if (ThirdApp.os == 'iphone') {
			_WK_DATAS["thirdLogin"] = {
				'url': url,
				'flag': '1',// 第三方调用登陆标示
			};
			setWebitEvent('_getThirdLoginInfo()', 'A1');
		}
	},

	/**
	 * 支付接口，上送json格式字符串
	 * 
	 * @param jsonDataStr
	 */
	thirdPay: function (jsonDataStr) {
		if (ThirdApp.os == 'android') {
			window.SysClientJs.thirdPay(jsonDataStr);
		} else if (ThirdApp.os == 'iphone') {
			_WK_DATAS["thirdPay"] = jsonDataStr;
			setWebitEvent('_getThirdPayInfo()', 'A2');// 支付函数
		}
	},

	/**
	 * 打开通讯录，用户选择号码后，回调callBack(mobileNo);
	 * 
	 * @param callBack
	 *            函数的字符串名称
	 */
	getContact: function (callBack) {
		try {
			if (ThirdApp.os == 'android') {
				var sendStr = {
					"callback": callBack
				};
				window.ThirdPartyJs.showContactView(ThirdApp.toJsonStr(sendStr));
			} else if (ThirdApp.os == 'iphone') {
				_WK_DATAS["getContact"] = {
					'callback': callBack
				};
				setWebitEvent("_getContact()", "AAA2");
			}
		} catch (e) {
			alert(e);
		}
	},

	/**
	 * 打开等待层
	 */
	showWaitPanel: function () {
		if (ThirdApp.os == 'android') {
			window.SysClientJs.showWaitPanel("加载中...");
		} else if (ThirdApp.os == 'iphone') {
			_WK_DATAS["wait"] = {
				'msg': '加载中...',
				'callback': '',
				'touchable': 'false'
			};
			setWebitEvent('showWaitPanel()', '04');
		}
	},

	/**
	 * 初始化标题
	 */
	initTitleInfo: function (pageId) {
		var json = ThirdApp._getPageTitle(pageId);
		if (ThirdApp.os == 'android') {
			window.ThirdPartyJs.updataTitleView(ThirdApp.toJsonStr(json));
		} else if (ThirdApp.os == 'iphone') {
			setWebitEvent(ThirdApp.toJsonStr(json), "AAA2");
		} else if (ThirdApp.os == 'web') {
		}
	},
	/**
	 * 移除原生头部标题
	 */
	removeNativeTitle: function () {
		if (ThirdApp.os == 'android') {
			var cfg = {
				title: "0",
				leftButton: {
					exist: "false",
					name: "",
					func: ""
				},
				rightButton: {
					exist: "false",
					name: "",
					func: ""
				}
			};
			SysClientJs.updateTitleInfo(ThirdApp.toJsonStr(cfg));
		} else if (ThirdApp.os == 'iphone') {
			setWebitEvent("ThirdApp._removeTitle()", "AAA2");
		}
	},
	_removeTitle: function () {
		var cfg = {
			title: "0",
			leftButton: {
				exist: "true",
				name: "",
				func: "backHome"
			},
			rightButton: {
				exist: "false",
				name: "",
				func: ""
			}
		};
		return ThirdApp.toJsonStr(cfg);
	},
	_getPageTitle: function (pageId) {
		var page = $(pageId);
		var cfg = {};
		var leftCfg = page.attr("data-btnLeft").split("|");
		cfg.leftButton = ThirdApp._generyTitleButton(leftCfg);
		cfg.rightButton = ThirdApp._generyRightTitleButton(page);
		if (ThirdApp.os == 'android') {
			cfg.title = this._generyTitleJson(page);
			cfg.type = page.attr("type") || "1";
			cfg.rightButton2 = ThirdApp._generyRightTitleButton2(page);
			cfg.isNeedHide = "false";
			var right2 = page.attr("data-btnRight2");
			if (!this.isEmpty(right2)) {
				cfg.type = "11";
			}
			return cfg;
		} else if (ThirdApp.os == 'iphone') {
			var type = page.attr("type");
			if (type == "4") {
				type = "3";
			}
			cfg.title = this._generyTitleJson_os(page);
			cfg.rightButton.type = type || "1";
			cfg.otherRightButton = ThirdApp._generyRightTitleButton2(page);
			cfg.otherRightButton.type = type || "1";
			return cfg;
		}

	},
	// 设置安卓原生返回键返回方法
	setBackBtn: function (func) {
		if (ThirdApp.os == 'android') {
			var cfg = {
				title: "",
				leftButton: {
					exist: "true",
					name: "",
					func: func
				},
				rightButton: {
					exist: "false",
					name: "",
					func: ""
				}
			};
			SysClientJs.updateTitleInfo(ThirdApp.toJsonStr(cfg));
		}
	},
	_generyTitleButton: function (cfg) {
		if (cfg && cfg.length == 3) {
			return {
				exist: cfg[0],
				name: cfg[1],
				func: cfg[2]
			};
		}
		return {
			exist: false,
			name: "",
			func: ""
		};
	},
	/**
	 * @param page
	 * @returns {___anonymous5601_5754}
	 */
	_generyTitleJson: function (page) {
		var type = page.attr("type");
		var titleArr = page.attr("data-titleArr");
		var fun, placeholder, position, list;
		if (type == "6") {
			// 查询框
			if (!this.isEmpty(titleArr)) {
				fun = titleArr.split("|")[1];
				placeholder = titleArr.split("|")[0];
			}
		} else if (type == "5" || type == "7") {
			if (!this.isEmpty(titleArr)) {
				position = titleArr.substring(0, titleArr.indexOf("|"));
				fun = titleArr.substring(titleArr.lastIndexOf("|") + 1);
				var listArr = titleArr.substring(titleArr.indexOf("|") + 1,
					titleArr.lastIndexOf("|")); // ['0|全部','1|收入','2|指出']
				listArr = eval(listArr);
				list = [];
				$.each(listArr, function (index, val) {
					list.push({
						"key": val.split("|")[0],
						"value": val.split("|")[1]
					});
				});
			}
		}
		return {
			showText: page.attr("title"),
			func: fun || "",
			hint: placeholder || "",
			showPosition: position || "",
			showList: list || []
		};
	},
	/**
	 * ios
	 */
	_generyTitleJson_os: function (page) {
		var type = page.attr("type");
		var titleArr = page.attr("data-titleArr");
		var fun, placeholder, position, list;
		if (type == "2" || type == "4") {
			type = "1";
		} else if (type == "6") {
			// 查询框
			type = "4";
			if (!this.isEmpty(titleArr)) {
				fun = titleArr.split("|")[1];
				placeholder = titleArr.split("|")[0];
			}
		} else if (type == "5" || type == "7") {
			// 下拉框
			if (type == "5") {
				type = "2";
			} else {
				type = "5"
			}
			if (!this.isEmpty(titleArr)) {
				position = titleArr.substring(0, titleArr.indexOf("|"));
				fun = titleArr.substring(titleArr.lastIndexOf("|") + 1);
				var listArr = titleArr.substring(titleArr.indexOf("|") + 1,
					titleArr.lastIndexOf("|")); // ['0|全部','1|收入','2|指出']
				listArr = eval(listArr);
				list = [];
				$.each(listArr, function (index, val) {
					list.push({
						"key": val.split("|")[0],
						"value": val.split("|")[1]
					});
				});
				// Fw.log(list);
			}
		}

		return {
			showText: page.attr("title"),
			type: type || "1",
			func: fun || "",
			hint: placeholder || "",
			showPosition: position || "",
			showList: list || []
		};
	},
	/**
	 * 右侧按钮1
	 * 
	 * @param page
	 * @returns
	 */
	_generyRightTitleButton: function (page) {
		var cfg = page.attr("data-btnRight").split("|");
		var rightArr = page.attr("data-rightArr");
		var list = [];
		if (!this.isEmpty(rightArr)) {
			rightArr = eval(rightArr);
			$.each(rightArr, function (index, val) {
				list.push({
					"key": val.split("|")[0],
					"value": val.split("|")[1]
				});
			});
		}

		if (cfg && cfg.length == 3) {
			return {
				exist: cfg[0],
				showText: cfg[1],
				func: cfg[2],
				showList: list,
			};
		}
		return {
			exist: "false"
		};
	},
	/**
	 * 右侧按钮2
	 * 
	 * @param page
	 * @returns
	 */
	_generyRightTitleButton2: function (page) {
		if (!this.isEmpty(page.attr("data-btnRight2"))) {
			var cfg = page.attr("data-btnRight2").split("|");
			var rightArr = page.attr("data-rightArr2");
			var list = [];
			if (!this.isEmpty(rightArr)) {
				rightArr = eval(rightArr);
				$.each(rightArr, function (index, val) {
					list.push({
						"key": val.split("|")[0],
						"value": val.split("|")[1]
					});
				});
			}

			if (cfg && cfg.length == 3) {
				return {
					exist: cfg[0],
					showText: cfg[1],
					func: cfg[2],
					showList: list
				};
			}
			return {
				exist: "false"
			};
		} else {
			return {
				exist: "false"
			};
		}
	},
	/**
	 * 隐藏Title
	 */
	hideTitle: function (pageId) {
		var json = ThirdApp._getPageTitle(pageId);
		if (ThirdApp.os == "android" || ThirdApp.os == "web") {
			json.isNeedHide = "true";
			window.ThirdPartyJs.updataTitleView(ThirdApp.toJsonStr(json));
		} else {
			var json = {
				"exit": "true"
			}
			setWebitEvent(ThirdApp.toJsonStr(json), "AAA3");
		}
	},
	/**
	 * 展示Title
	 */
	showTitle: function (pageId) {
		if (ThirdApp.os == "android") {
			var json = ThirdApp._getPageTitle(pageId);
			json.isNeedHide = "false";
			window.ThirdPartyJs.updataTitleView(ThirdApp.toJsonStr(json));
		} else {
			var json = {
				"exit": "false"
			}
			setWebitEvent(ThirdApp.toJsonStr(json), "AAA3");
		}

	},
	// 调用拨打电话
	gotoCall: function (m) {
		if (ThirdApp.os == 'android') {
			window.SysClientJs.gotoCall(m);
		} else if (ThirdApp.os == 'iphone') {
			try {
				_WK_DATAS["gotoCall"] = {
					'tel': m
				};
				setWebitEvent("_gotoCall()", "A9");
			} catch (e) {
				alert(e);
			}
		}
	},
	// 获取手机号码
	getMobileNo: function (func) {
		if (ThirdApp.os == 'android') {
			window.SysClientJs.getMobileNo(func);
		} else if (ThirdApp.os == 'iphone') {
			try {
				_WK_DATAS["getMobileNo"] = {
					'callback': func
				};
				setWebitEvent("_getMobileNo()", "C1");
			} catch (e) {
				alert(e);
			}
		}
	},
	// 下载文件
	downloadFile: function (url, name) {
		if (ThirdApp.os == 'android') {
			window.SysClientJs.downloadFile(url, name);
		} else if (ThirdApp.os == 'iphone') {
			try {
				_WK_DATAS["downloadFile"] = {
					url: url,
					name: name
				};
				setWebitEvent("_downloadFile()", "42");
			} catch (e) {
				alert(e);
			}
		}
	},

	/**
	 * 跳转到登录页面
	 * @param callback
	 */
	isLogin: function (callback) {
		if (ThirdApp.os == 'android') {
			window.ThirdPartyJs.gotoLogin();
			// window.SysClientJs.isLogin(callback);
		} else if (ThirdApp.os == 'iphone') {
			try {
				_WK_DATAS["isLogin"] = {
					callback: callback
				};
				setWebitEvent("_getIsLogin()", "01");
			} catch (e) {
				alert(e);
			}
		}
	},


	/**
	 * 跳转到登录页面，登录成功后跳转到指定页面
	 * @param param JSON  {"pmm_url":"szbank://trans?isLogin=1|title=抵扣币商城|commercialId=100000000004|directUrl=http://xxxxxx.com"}
	 */
	gotoLogin: function (param) {
		param.pmm_from = "page";
		var params = JSON.stringify(param);
		if (ThirdApp.os == 'android') {
			window.ThirdPartyJs.gotoLoginRefresh(params);
		} else if (ThirdApp.os == 'iphone') {
			setWebitEvent(params, "001");
		}
	},

	// 获取客户号
	getCustNo: function (callback) {
		if (ThirdApp.os == 'android') {
			window.SysClientJs.getCustNo(callback);
		} else if (ThirdApp.os == 'iphone') {
			try {
				_WK_DATAS["getCustNo"] = {
					callback: callback
				};
				setWebitEvent("_getCustNo()", "C2");
			} catch (e) {
				alert(e);
			}
		}
	},
	// 弹框提示
	alertinfo: function (c) {
		var a = {
			title: "温馨提示",
			info: c,
			type: "4",
			imageFlag: "2",
			ok_text: "确定",
			ok_func: "",
			cancel_text: "",
			cancel_func: ""
		};
		if (ThirdApp.os == 'android') {
			window.SysClientJs.alertinfo(ThirdApp.toJsonStr(a));
		} else if (ThirdApp.os == 'iphone') {
			_WK_DATAS["thirdAlert"] = ThirdApp.toJsonStr(a);
			setWebitEvent("_getAlertInfo()", "25");
		}
	},

	/**
	 * 解析JSON，兼容不支持JSON对象的浏览器
	 * 
	 * @param str
	 * @returns
	 */
	parseJson: function (str) {
		var obj;
		try {
			obj = JSON.parse(str);
		} catch (e) {
			obj = eval("(" + str + ")");
		}
		return obj;
	},


	/**
	 * 将对象转换成json字符串
	 * 
	 * @param obj
	 */
	toJsonStr: function (obj) {
		if (JSON.stringify) {
			return JSON.stringify(obj);
		}
		if (obj == null) {
			return '""';
		}
		switch (typeof (obj)) {
			default:
			case 'number':
			case 'string':
				return '"' + obj + '"';
			case 'object': {
				if (obj instanceof Array) {
					var strArr = [];
					var len = obj.length;
					for (var i = 0; i < len; i++) {
						strArr.push(ThirdApp.toJsonStr(obj[i]));
					}
					return '[' + strArr.join(',') + ']';
				} else {
					var arr = [];
					for (var i in obj) {
						arr.push('"' + i + '":' + ThirdApp.toJsonStr(obj[i]));
					}
					return "{" + arr.join(',') + "}";
				}
			}
		}
		return '""';
	},



	/**
	 * App对象初始化
	 */
	init: function () {
		ThirdApp.checkOs();
		if (ThirdApp.os == 'iphone') {
			var W = window;
			// 事件队列
			W._mevents = new Array();
			W._ajaxArray = new Array();
			// push 增加入队列
			// shift 先进先出
			// 设置自定义事件
			W.setWebitEvent = function (evtName, evtCode) {
				if (evtName == "") {
					return;
				}
				_mevents.push({
					code: evtCode,
					name: evtName
				});
			};

			// 至此以下的函数全部由上层iphone调用
			// iphone调用获取EventCode
			W.getWebkitEventCode = function () {
				return _mevents.length > 0 ? ThirdApp.toJsonStr(_mevents
					.shift()) : "0";
			};
			// 获取自定义事件
			W.getWebkitEvent = function () {
				return "";
			};

			W._WK_DATAS = [];
			W._WK_DATAS["wait"] = {
				'msg': '',
				'callback': '',
				'touchable': 'false'
			};
			W.showWaitPanel = function () {
				return ThirdApp.toJsonStr(_WK_DATAS["wait"]);
			};
			W.closeWaitPanel = function () {
				_WK_DATAS["wait"] = {};
			};

			W._WK_DATAS["alert"] = {
				'title': '温馨提示',
				'msg': '测试信息'
			};
			// 获取提示信息
			W._getAlertInfo = function () {
				// return ThirdApp.toJsonStr(_WK_DATAS["thirdAlert"]);
				return _WK_DATAS["thirdAlert"];
			};

			// 获取客户端参数
			W._WK_DATAS["payMent"] = {
				callback: ''
			};

			// // 获取通讯录
			W._getContact = function () {
				return ThirdApp.toJsonStr(_WK_DATAS["getContact"]);
			};

			// 获取支付数据
			W._getThirdPayInfo = function () {
				return _WK_DATAS["thirdPay"];
			};

			// 获取登陆成功后续跳转的url
			W._getThirdLoginInfo = function () {
				return ThirdApp.toJsonStr(_WK_DATAS["thirdLogin"]);
			};

			W.buileFootdiv = function (ele, rootele) {
				var jianpanH = 210;
				var eleHeight = ele.scrollHeight;
				if (eleHeight < jianpanH) {
					var result = jianpanH - eleHeight;
					return result;
				} else {
					return 0;
				}
			};
			W._toHomePage = function () {
				return ThirdApp.toJsonStr(_WK_DATAS["toHomePage"]);
			};
			// // 获取通讯录
			W._gotoCall = function () {
				return ThirdApp.toJsonStr(_WK_DATAS["gotoCall"]);
			};
			// 获取手机号码
			W._getMobileNo = function () {
				return ThirdApp.toJsonStr(_WK_DATAS["getMobileNo"]);
			};
			W._downloadFile = function () {
				return ThirdApp.toJsonStr(_WK_DATAS["downloadFile"]);
			};
			W._getIsLogin = function () {
				return ThirdApp.toJsonStr(_WK_DATAS["isLogin"]);
			};
			W._getCustNo = function () {
				return ThirdApp.toJsonStr(_WK_DATAS["getCustNo"]);
			};
		}
	},
	/**
	 * 判断操作平台
	 */
	checkOs: function () {
		var ua = navigator.userAgent;
		var android = ua.match(/(Android);?[\s\/]+([\d.]+)?/);
		var ipad = ua.match(/(iPad).*OS\s([\d_]+)/);
		var ipod = ua.match(/(iPod)(.*OS\s([\d_]+))?/);
		var iphone = !ipad && ua.match(/(iPhone\sOS)\s([\d_]+)/);

		ThirdApp.os = "web";
		if (android) {
			ThirdApp.os = "android";
		}
		if (ipad || iphone || ipod) {
			ThirdApp.os = "iphone";
		}

	},
	/**
	 * 显示页面
	 * @param showHandle
	 * @param hideHandles
	 * @param showTitle
	 */
	showPageArea: function (showHandle, hideHandles, showTitle) {
		if (hideHandles) {
			$.each(hideHandles, function (item) {
				$(item).removeClass("current");
			});
		}
		$(showHandle).addClass("current");

		if (showTitle === true) {
			ThirdApp.initTitleInfo(showHandle);
		}

	},
	/**
	 * 跳转页面
	 */
	webViewJump: function (data) {
		var param = {
			"ppi_linktype": data.linktype,
			"ppi_skipflag": data.skipflag,
			"ppi_skipaddr": data.skipaddr,
			"ppi_detailtype": data.detailtype,
			"callBack": data.callBack
		}
		if (ThirdApp.os == "android") {
			window.ThirdPartyJs.webViewJump(ThirdApp.toJsonStr(param));
			return;
		} else if (ThirdApp.os == "iphone") {
			if (param.ppi_linktype == "06") {
				setWebitEvent(ThirdApp.toJsonStr(param), "AAA8");
				return;
			} else {
				setWebitEvent(ThirdApp.toJsonStr(param), "AAA9");
				return;
			}
		}
	},
	/**
	 * 分享
	 */
	webviewShare: function (param) {
		if (ThirdApp.os == "android") {
			window.ThirdPartyJs.webviewShare(ThirdApp.toJsonStr(param));
		} else {
			setWebitEvent(ThirdApp.toJsonStr(param), "AAA7");
		}
	},
	/**
	 * 获取硬件信息1 
	 */
	getNewDeviceInfo: function (param) {
		if (ThirdApp.os == "android") {
			window.ThirdPartyJs.getNewDeviceInfo(ThirdApp.toJsonStr(param));
		} else if (ThirdApp.os == "iphone") {
			setWebitEvent(ThirdApp.toJsonStr(param), "AAA5");
		}
	},
	/**
	 * 获取硬件信息2 
	 */
	getAppNetSpeed: function (param) {
		if (ThirdApp.os == "android") {
			window.ThirdPartyJs.getAppNetSpeed(ThirdApp.toJsonStr(param));
		} else if (ThirdApp.os == "iphone") {
			setWebitEvent(ThirdApp.toJsonStr(param), "AAA6");
		}
	},
	/**
	 * 获取CPU使用率 
	 */
	getAppCpuUse: function (param) {
		if (ThirdApp.os == "android") {
			window.ThirdPartyJs.getAppCpuUse(ThirdApp.toJsonStr(param));
		} else if (ThirdApp.os == "iphone") {
			setWebitEvent(ThirdApp.toJsonStr(param), "AAA4");
		}
	},
	/**
	 * 使用流量 
	 */
	getAppNetUse: function (param) {
		if (ThirdApp.os == "android") {
			window.ThirdPartyJs.getAppNetUse(ThirdApp.toJsonStr(param));
		} else if (ThirdApp.os == "iphone") {
			setWebitEvent(ThirdApp.toJsonStr(param), "AAA1");
		}
	},
	/**
	 * 使用内存
	 */
	getAppRamUse: function (param) {
		if (ThirdApp.os == "android") {
			window.ThirdPartyJs.getAppRamUse(ThirdApp.toJsonStr(param));
		} else if (ThirdApp.os == "iphone") {
			setWebitEvent(ThirdApp.toJsonStr(param), "AAA10");
		}
	},
	/**
	 * 电池温度
	 */
	getBatteryInfo: function (param) {
		if (ThirdApp.os == "android") {
			window.ThirdPartyJs.getBatteryInfo(ThirdApp.toJsonStr(param));
		} else if (ThirdApp.os == "iphone") {
			setWebitEvent(ThirdApp.toJsonStr(param), "AAA11");
		}
	},
	/**
	 * 获取经纬度
	 */
	getLocation: function (param) {
		if (ThirdApp.os == "android") {
			window.ThirdPartyJs.getLocation(ThirdApp.toJsonStr(param));
		} else if (ThirdApp.os == "iphone") {
			setWebitEvent(ThirdApp.toJsonStr(param), "AAA5");
		}
	},
	/**
	 * 模仿招商附件预览
	 */
	jumptoBrower: function (param) {
		if (ThirdApp.os == "android") {
			window.ThirdPartyJs.jumptoBrower(ThirdApp.toJsonStr(param));
		}
	},
	/**
		* 是否为空
		* @param v  {*} 值
		* @param allowBlank {boolean} 是否允许空
		* @returns {boolean|*}
		*/
	isEmpty: function (v, allowBlank) {
		return v === null || v === undefined
			|| String(v).toUpperCase() === 'NULL'
			|| String(v).toUpperCase() === 'UNDEFINED'
			|| ((this.isArray(v) && !v.length))
			|| (!allowBlank ? v === '' : false);
	},
	/**
		 * 是否是数组
		 * @param v
		 * @returns {boolean}
		 */
	isArray: function (v) {
		return this.toString(v) === '[object Array]';
	},

	/**
		 * 转换为字符
		 * @param v {object}
		 * @returns {string}
		 */
	toString: function (v) {
		return Object.prototype.toString.apply(v);
	},
	/**
	 * session管理
	 */
	managerSession: function (param) {
		if (ThirdApp.os == "android") {
			window.ThirdPartyJs.managerSession(ThirdApp.toJsonStr(param));
		} else if (ThirdApp.os == "iphone") {
			setWebitEvent(ThirdApp.toJsonStr(param), "AAA12");
		}
	},
	/**
	 * 缓存管理
	 * @param param
	 */
	webCacheDateFun: function (param) {
		if (ThirdApp.os == "android") {
			window.ThirdPartyJs.webCacheDateFun(ThirdApp.toJsonStr(param));
		} else if (ThirdApp.os == "iphone") {
			setWebitEvent(ThirdApp.toJsonStr(param), "AAA14");
		}
	},
	/**
	 * 后台请求
	 * @param param
	 */
	ajaxData: function (param) {
		if (ThirdApp.os == "android") {
			window.ThirdPartyJs.post(ThirdApp.toJsonStr(param));
		} else if (ThirdApp.os == "iphone") {
			setWebitEvent(ThirdApp.toJsonStr(param), "AAA13");
		}
	},

	/**
	 * 根据函数获取函数名称
	 */
	getFunctionName: function (func, decodeURL) {
		if (Object.prototype.toString.apply(func) !== '[object Function]') {
			return func;
		}

		var funcName = 'func' + (++ID);
		// 创建可被调用的临时方法
		window[funcName] = function () {
			var args = [];
			ThirdApp.each(arguments, function (arg) {
				if (true == decodeURL) {
					arg = decodeURIComponent(arg);
				}
				if ('string' == typeof arg && '{' == arg.charAt(0) && '}' == arg.charAt(arg.length - 1)) {
					arg = eval("(" + arg + ")");
				}

				args.push(arg);
			}, this);
			func.apply(this, args);

			delete window[funcName];//删除临时方法
		};
		return funcName;
	},

	each: function (value, fn, scope) {
		if (ThirdApp.isEmpty(value)) {
			return;
		}
		if (!ThirdApp.isDefined(scope)) {
			scope = value;
		}
		if (ThirdApp.isObject(value)) {
			var i = 0;
			for (var prop in value) {
				if (value.hasOwnProperty(prop)) {
					if (fn.call(scope || value, prop, value[prop], i++, value) === false) {
						return;
					}
				}
			}
		} else {
			if (!ThirdApp.isIterable(value) || ThirdApp.isPrimitive(value)) {
				value = [value];
			}
			for (var i = 0, len = value.length; i < len; i++) {
				if (fn.call(scope || value[i], value[i], i, value) === false) {
					return i;
				}
			}
		}
	},

	isEmpty: function (v, allowBlank) {
		return v === null || v === undefined
			|| String(v).toUpperCase() === 'NULL'
			|| String(v).toUpperCase() === 'UNDEFINED'
			|| ((ThirdApp.isArray(v) && !v.length))
			|| (!allowBlank ? v === '' : false);
	},

	isDefined: function (v) {
		return typeof v !== 'undefined';
	},

	isObject: function (v) {
		return !!v && toString(v) === '[object Object]';
	},

	isIterable: function (v) {
		return (v && typeof v !== 'string') ? ThirdApp.isDefined(v.length) : false;
	},

	isPrimitive: function (v) {
		return ThirdApp.isString(v) || ThirdApp.isNumber(v) || ThirdApp.isBoolean(v);
	},

	isArray: function (v) {
		return toString(v) === '[object Array]';
	},

	isString: function (v) {
		return typeof v === 'string';
	},

	isNumber: function (v) {
		return typeof v === 'number' && isFinite(v);
	},

	isBoolean: function (v) {
		return typeof v === 'boolean';
	},

	/**
	 * 关闭第三方页面
	 */
	colseViewPage: function (param) {
		if (ThirdApp.os == "android") {
			window.ThirdPartyJs.finishWebView(ThirdApp.toJsonStr(param));
		} else if (ThirdApp.os == "iphone") {
			setWebitEvent(ThirdApp.toJsonStr(param), "AAA22");
		}
	},

	disableRefresh: function () {
		if (ThirdApp.os == "android") {

		} else if (ThirdApp.os == "iphone") {
			setWebitEvent("", "AAA24");
		}
	}
};
